// $ANTLR 2.7.7 (20060906): "Expression.g" -> "TreeParser.cs"$

using System.IO;

namespace Agilent.Vee.EvoExample.ExpressionGraph
{
	// Generate header specific to the tree-parser CSharp file
	using System;
	
	using TreeParser = antlr.TreeParser;
	using Token                    = antlr.Token;
	using IToken                   = antlr.IToken;
	using AST                      = antlr.collections.AST;
	using RecognitionException     = antlr.RecognitionException;
	using ANTLRException           = antlr.ANTLRException;
	using NoViableAltException     = antlr.NoViableAltException;
	using MismatchedTokenException = antlr.MismatchedTokenException;
	using SemanticException        = antlr.SemanticException;
	using BitSet                   = antlr.collections.impl.BitSet;
	using ASTPair                  = antlr.ASTPair;
	using ASTFactory               = antlr.ASTFactory;
	using ASTArray                 = antlr.collections.impl.ASTArray;
	
	
	public 	class TreeParser : antlr.TreeParser
	{
		public const Int32 EOF = 1;
		public const Int32 NULL_TREE_LOOKAHEAD = 3;
		public const Int32 SIGN_MINUS = 4;
		public const Int32 SIGN_PLUS = 5;
		public const Int32 LPAREN = 6;
		public const Int32 RPAREN = 7;
		public const Int32 PLUS = 8;
		public const Int32 MINUS = 9;
		public const Int32 MUL = 10;
		public const Int32 DIV = 11;
		public const Int32 POW = 12;
		public const Int32 ABS = 13;
		public const Int32 ACOS = 14;
		public const Int32 ASIN = 15;
		public const Int32 ATAN = 16;
		public const Int32 COS = 17;
		public const Int32 EXP = 18;
		public const Int32 LOG = 19;
		public const Int32 LOG10 = 20;
		public const Int32 SQRT = 21;
		public const Int32 SIN = 22;
		public const Int32 TAN = 23;
		public const Int32 NUMBER = 24;
		public const Int32 X = 25;
		public const Int32 WS = 26;
		
		
	private AST _ast;
	
	public TreeParser(string expression) : this()
	{
		Lexer lexer = new Lexer(new StringReader(expression));
		Parser parser = new Parser(lexer);
		parser.expr();
		_ast = parser.getAST();
	}
	
	public Double XValue { get; set; }
	
	public Double Value
	{
		get
		{
	  		Double y = eval(_ast);
	  		return y;
		}
	}
		public TreeParser()
		{
			tokenNames = tokenNames_;
		}
		
	public Double  eval(AST _t) //throws RecognitionException
{
		Double v = 0;
		
		AST eval_AST_in = (AST)_t;
		
		try {      // for error handling
			v=expr(_t);
			_t = retTree_;
		}
		catch (RecognitionException ex)
		{
			reportError(ex);
			if (null != _t)
			{
				_t = _t.getNextSibling();
			}
		}
		retTree_ = _t;
		return v;
	}
	
	protected Double  expr(AST _t) //throws RecognitionException
{
		Double v = 0;
		
		AST expr_AST_in = (AST)_t;
		AST i = null;
		AST x = null;
		
			Double l = 0;
			Double r = 0;
		
		
		try {      // for error handling
			if (null == _t)
				_t = ASTNULL;
			switch ( _t.Type )
			{
			case NUMBER:
			{
				i = _t;
				match(_t,NUMBER);
				_t = _t.getNextSibling();
				v = Convert.ToDouble(i.getText());
				break;
			}
			case X:
			{
				x = _t;
				match(_t,X);
				_t = _t.getNextSibling();
				v = XValue;
				break;
			}
			case ABS:
			{
				AST __t50 = _t;
				AST tmp1_AST_in = _t;
				match(_t,ABS);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t50;
				_t = _t.getNextSibling();
				v = Math.Abs(l);
				break;
			}
			case ACOS:
			{
				AST __t51 = _t;
				AST tmp2_AST_in = _t;
				match(_t,ACOS);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t51;
				_t = _t.getNextSibling();
				v = Math.Acos(l);
				break;
			}
			case ASIN:
			{
				AST __t52 = _t;
				AST tmp3_AST_in = _t;
				match(_t,ASIN);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t52;
				_t = _t.getNextSibling();
				v = Math.Asin(l);
				break;
			}
			case ATAN:
			{
				AST __t53 = _t;
				AST tmp4_AST_in = _t;
				match(_t,ATAN);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t53;
				_t = _t.getNextSibling();
				v = Math.Atan(l);
				break;
			}
			case COS:
			{
				AST __t54 = _t;
				AST tmp5_AST_in = _t;
				match(_t,COS);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t54;
				_t = _t.getNextSibling();
				v = Math.Cos(l);
				break;
			}
			case EXP:
			{
				AST __t55 = _t;
				AST tmp6_AST_in = _t;
				match(_t,EXP);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t55;
				_t = _t.getNextSibling();
				v = Math.Exp(l);
				break;
			}
			case LOG:
			{
				AST __t56 = _t;
				AST tmp7_AST_in = _t;
				match(_t,LOG);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t56;
				_t = _t.getNextSibling();
				v = Math.Log(l);
				break;
			}
			case LOG10:
			{
				AST __t57 = _t;
				AST tmp8_AST_in = _t;
				match(_t,LOG10);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t57;
				_t = _t.getNextSibling();
				v = Math.Log10(l);
				break;
			}
			case SQRT:
			{
				AST __t58 = _t;
				AST tmp9_AST_in = _t;
				match(_t,SQRT);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t58;
				_t = _t.getNextSibling();
				v = Math.Sqrt(l);
				break;
			}
			case SIN:
			{
				AST __t59 = _t;
				AST tmp10_AST_in = _t;
				match(_t,SIN);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t59;
				_t = _t.getNextSibling();
				v = Math.Sin(l);
				break;
			}
			case TAN:
			{
				AST __t60 = _t;
				AST tmp11_AST_in = _t;
				match(_t,TAN);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t60;
				_t = _t.getNextSibling();
				v = Math.Tan(l);
				break;
			}
			case PLUS:
			{
				AST __t61 = _t;
				AST tmp12_AST_in = _t;
				match(_t,PLUS);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				r=expr(_t);
				_t = retTree_;
				_t = __t61;
				_t = _t.getNextSibling();
				v = l + r;
				break;
			}
			case MINUS:
			{
				AST __t62 = _t;
				AST tmp13_AST_in = _t;
				match(_t,MINUS);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				r=expr(_t);
				_t = retTree_;
				_t = __t62;
				_t = _t.getNextSibling();
				v = l + r;
				break;
			}
			case DIV:
			{
				AST __t63 = _t;
				AST tmp14_AST_in = _t;
				match(_t,DIV);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				r=expr(_t);
				_t = retTree_;
				_t = __t63;
				_t = _t.getNextSibling();
				v = l / r;
				break;
			}
			case MUL:
			{
				AST __t64 = _t;
				AST tmp15_AST_in = _t;
				match(_t,MUL);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				r=expr(_t);
				_t = retTree_;
				_t = __t64;
				_t = _t.getNextSibling();
				v = l * r;
				break;
			}
			case POW:
			{
				AST __t65 = _t;
				AST tmp16_AST_in = _t;
				match(_t,POW);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				r=expr(_t);
				_t = retTree_;
				_t = __t65;
				_t = _t.getNextSibling();
				v = Math.Pow(l, r);
				break;
			}
			case SIGN_MINUS:
			{
				AST __t66 = _t;
				AST tmp17_AST_in = _t;
				match(_t,SIGN_MINUS);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t66;
				_t = _t.getNextSibling();
				v = 0 - l;
				break;
			}
			case SIGN_PLUS:
			{
				AST __t67 = _t;
				AST tmp18_AST_in = _t;
				match(_t,SIGN_PLUS);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t67;
				_t = _t.getNextSibling();
				v = l;
				break;
			}
			case LPAREN:
			{
				AST __t68 = _t;
				AST tmp19_AST_in = _t;
				match(_t,LPAREN);
				_t = _t.getFirstChild();
				l=expr(_t);
				_t = retTree_;
				_t = __t68;
				_t = _t.getNextSibling();
				v = l;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			 }
		}
		catch (RecognitionException ex)
		{
			reportError(ex);
			if (null != _t)
			{
				_t = _t.getNextSibling();
			}
		}
		retTree_ = _t;
		return v;
	}
	
	
	public static readonly string[] tokenNames_ = new string[] {
		@"""<0>""",
		@"""EOF""",
		@"""<2>""",
		@"""NULL_TREE_LOOKAHEAD""",
		@"""SIGN_MINUS""",
		@"""SIGN_PLUS""",
		@"""LPAREN""",
		@"""RPAREN""",
		@"""PLUS""",
		@"""MINUS""",
		@"""MUL""",
		@"""DIV""",
		@"""POW""",
		@"""ABS""",
		@"""ACOS""",
		@"""ASIN""",
		@"""ATAN""",
		@"""COS""",
		@"""EXP""",
		@"""LOG""",
		@"""LOG10""",
		@"""SQRT""",
		@"""SIN""",
		@"""TAN""",
		@"""NUMBER""",
		@"""X""",
		@"""WS"""
	};
	
}

}
